#pragma once
#include "leet.h"

std::vector<std::vector<int>> Solution::threeSum(std::vector<int>& nums) {
	std::vector<std::vector<int>> ans;

	//itterate through map O(n^2) and create a map of the sums of each element
	for (int i = 0; i < nums.size(); i++)
	{
		for (int j = i+1; j < nums.size(); j++)
		{
			sums[nums[i] + nums[j]] = std::vector<int>{i, j};
		}
	}

	for (int i = 0; i < nums.size(); i++)
	{
		if (sums.count(0-nums[i]))
		{//If required value is in map
			std::vector<int> indexes = sums[0-nums[i]];
			if (i == indexes[0] || i == indexes[1])
				continue;
			ans.push_back({ nums[i], nums[indexes[0]], nums[indexes[1]] });
		}
	}

	return ans;
}

//
//Given an integer array nums, return all the triplets[nums[i], nums[j], nums[k]] 
// such that i != j, i != k, and j != k, and nums[i] + nums[j] + nums[k] == 0.
//
//Notice that the solution set must not contain duplicate triplets.